# ``twisted`.`web`.`http_headers`.`Headers``

class documentation

`class Headers: (source)`

View In Hierarchy

Stores HTTP headers in a key and multiple value format.

When passed `str`, header names (e.g. 'Content-Type') are encoded using ISO-8859-1 and header values (e.g. 'text/html;charset=utf-8') are encoded using UTF-8. Some methods that return values will return them in the same type as the name given.

If the header keys or values cannot be encoded or decoded using the rules above, using just `bytes` arguments to the methods of this class will ensure no decoding or encoding is done, and `Headers` will treat the keys and values as opaque byte strings.

Method | `__cmp__` | Define `Headers` instances as being equal to each other if they have the same raw headers.
Method | `__init__` | Undocumented
Method | `__repr__` | Return a string fully describing the headers set on this object.
Method | `addRawHeader` | Add a new raw value for the given header.
Method | `copy` | Return a copy of itself with the same headers set.
Method | `getAllRawHeaders` | Return an iterator of key, value pairs of all headers contained in this object, as `bytes`. The keys are capitalized in canonical capitalization.
Method | `getRawHeaders` | Returns a sequence of headers matching the given name as the raw string given.
Method | `hasHeader` | Check for the existence of a given header.
Method | `removeHeader` | Remove the named header from this header object.
Method | `setRawHeaders` | Sets the raw representation of the given header.
Method | `_canonicalNameCaps` | Return the canonical name for the given header.
Method | `_encodeName` | Encode the name of a header (eg 'Content-Type') to an ISO-8859-1 encoded bytestring if required.
Class Variable | `_caseMappings` | A `dict` that maps lowercase header names to their canonicalized representation.
Instance Variable | `_rawHeaders` | A `dict` mapping header names as `bytes` to `list`s of header values as `bytes`.

def __cmp__(self, other): (source)
Define `Headers` instances as being equal to each other if they have the same raw headers.
def __init__(self, rawHeaders=None): (source)

Undocumented

Parameters
rawHeaders:`Optional[Mapping[AnyStr, Sequence[AnyStr]]]` | Undocumented

def __repr__(self): (source)
Return a string fully describing the headers set on this object.

Returns
`str` | Undocumented

def addRawHeader(self, name, value): (source)
Add a new raw value for the given header.

Parameters
name:`AnyStr` | The name of the header for which to set the value.
value:`AnyStr` | The value to set for the named header.

def copy(self): (source)
Return a copy of itself with the same headers set.

Returns
A new `Headers`

def getAllRawHeaders(self): (source)
Return an iterator of key, value pairs of all headers contained in this object, as `bytes`. The keys are capitalized in canonical capitalization.

Returns
`Iterator[Tuple[bytes, Sequence[bytes]]]` | Undocumented

def getRawHeaders(self, name, default=None): (source)
Returns a sequence of headers matching the given name as the raw string given.

Parameters
name:`AnyStr` | The name of the HTTP header to get the values of.
default:`Optional[_T]` | The value to return if no header with the given `name` exists.
Returns
`Union[Sequence[AnyStr], Optional[_T]]` | If the named header is present, a sequence of its values. Otherwise, `default`.

def hasHeader(self, name): (source)
Check for the existence of a given header.

Parameters
name:`AnyStr` | The name of the HTTP header to check for.
Returns
`bool` | `True` if the header exists, otherwise `False`.

def removeHeader(self, name): (source)
Remove the named header from this header object.

Parameters
name:`AnyStr` | The name of the HTTP header to remove.
Returns
`None`

def setRawHeaders(self, name, values): (source)
Sets the raw representation of the given header.

Parameters
name:`AnyStr` | The name of the HTTP header to set the values for.
values:`Sequence[AnyStr]` | A list of strings each one being a header value of the given name.
Returns
`None`
Raises
`TypeError` | Raised if `values` is not a `list` of `bytes` or `str` strings, or if `name` is not a `bytes` or `str` string.

def _canonicalNameCaps(self, name): (source)
Return the canonical name for the given header.

Parameters
name:`bytes` | The all-lowercase header name to capitalize in its canonical form.
Returns
`bytes` | The canonical name of the header.

def _encodeName(self, name): (source)
Encode the name of a header (eg 'Content-Type') to an ISO-8859-1 encoded bytestring if required.

Parameters
name:`AnyStr` | A HTTP header name
Returns
`bytes` | `name`, encoded if required, lowercased

_caseMappings: `dict[bytes, bytes]` = (source)
A `dict` that maps lowercase header names to their canonicalized representation.
_rawHeaders: `Dict[bytes, List[bytes]]` = (source)
A `dict` mapping header names as `bytes` to `list`s of header values as `bytes`.